<?php
session_start();
ob_start();
include("include/dbconnect.php");
include("include/functions.php");
require_once("tcpdf/tcpdf.php");
if($_SESSION['VALID_USER_NAME'] == false)
{
    header("location: login");
}


class PDF extends TCPDF
{

    //Page header
    public function Header()
    {

        // Logo
        $image_file = 'images/kt_logo_final.png';
        $this->Image($image_file, 12, 5, 30, '30', 'png', '', 'T', false, 300, '', false, false, 0, false, false, false);
        // Set font




    }


}




// create new PDF document
$pdf = new PDF(PDF_PAGE_ORIENTATION, PDF_UNIT, 'PDF_PAGE_FORMAT', true, 'UTF-8', false);




// Start First Page Group
$pdf->startPageGroup();

$pdf->AddPage('L', 'A4');

$pdf->setFontSubsetting(false);

$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE.' 001', PDF_HEADER_STRING);

// set header and footer fonts
$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

// set default monospaced font
$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

//set margins
$pdf->SetLeftMargin(1);

$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

//set auto page breaks
$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);


$font_cal = TCPDF_FONTS::addTTFfont('tcpdf/fonts/Calibri/Calibri Regular.ttf', 'TrueTypeUnicode', '', 32);
$font_cal_bold = TCPDF_FONTS::addTTFfont('tcpdf/fonts/Calibri/Calibri Bold.TTF', 'TrueTypeUnicode', '', 32);
$arial_fontname = TCPDF_FONTS::addTTFfont('tcpdf/fonts/ARIALBD.TTF', 'TrueTypeUnicode', '', 32);


$from_date = clean_data($_GET['from_date']);
$change_from_date = strtotime($from_date);
$new_from_date = date('Y-m-d', $change_from_date);

$to_date = clean_data($_GET['to_date']);
$change_to_date = strtotime($to_date);
$new_to_date = date('Y-m-d', $change_to_date);
$cur_date = date('d-m-Y');


$find_comp_name = find_value("v_system","comp_name", "");





$pdf->SetFont('times', 'B', 26);

$pdf->Cell(0, 5,  $find_comp_name, '0', 0, 'C', 0, false, 'M', 'M');
$pdf->ln(6);
$pdf->SetFont('times', 'B', 12);
$pdf->Cell(0, 5,  'Daily Summary Report', '0', 0, 'C', 0, false, 'M', 'M');
$pdf->ln(5);
$pdf->SetFont($font_cal, 'B', 12);
$pdf->Cell(0, 5,  $from_date . ' - ' . $to_date, '0', 0, 'C', 0, false, 'M', 'M');

$and = "";
//$and .= " and (v.voucher_date BETWEEN '$new_from_date' and '$new_to_date')";
$pdf->ln(15);


$month = date("m",strtotime($new_from_date));
$curr_month_from_date = date('Y-'.$month.'-01');


$pdf->SetFont($font_cal, '', 8);
$a = '
  <table  border="1" id="table-1"  style="text-align: center; " cellpadding="5">
                                <thead>
                                <tr>
                    <th colspan="6" style="text-align: center; font-size: 16px; font-weight: bold;">Receipts</th>
                    <th colspan="6" style="text-align: center; font-size: 16px; font-weight: bold;">Payments</th>
                   <th colspan="2" style="text-align: center; font-size: 16px; font-weight: bold;">Total Sale</th>
                </tr>

                <tr>
                    <th style="width: 7%;">Company</th>
                    <th style="width: 7%;">OB</th>
                    <th style="width: 7%;">Cash Sale</th>
                    <th style="width: 7%;">Credit Sale </th>
                    <th style="width: 7%;">Receiving</th>
                    <th style="width: 8%;">Total</th>


                   <th style="width: 7%;">Payment</th>
                    <th style="width: 7%;">Credit Sale </th>
                    <th style="width: 7%;">Cash In Hand</th>
                    <th style="width: 7%;">Purchase</th>
                    <th style="width: 7%;">Return</th>
                    <th style="width: 8%;">Total</th>


                    <th  style="width: 7%;">Cash Sale</th>
                    <th  style="width: 7%;">Credit Sale </th>


                </tr>
                                </thead>
                                <tbody style="color: #000000;">' ;

try {
    $v_query =  "SELECT DISTINCT
	n.comp_id,
	n.cash_sale,
	n.credit_sale,
	n.cash_received,
	n.cash_payment,
	n.cash_purchase,
	n.sale_return,
    n.voucher_date,
    n.month_cash_sale,
    n.month_credit_sale
	
FROM
	(
	SELECT
		v.comp_id,
	    v.voucher_date,
		c.cash_sale,
		c2.credit_sale,
		c3.cash_received,
		c4.cash_payment,
		c5.cash_purchase,
		c6.sale_return,
	    c7.month_cash_sale,
	    c8.month_credit_sale
		
	FROM
		v_vouchers v
		LEFT JOIN (
		SELECT
			v2.comp_id,
			SUM( v2.debit ) cash_sale 
		FROM
			v_vouchers v2 
		WHERE
			1 = 1 
			AND substr( v2.voucher_id, 3, 2 ) = 'SL' 
			AND v2.cash = 'Y' 
			and v2.voucher_date BETWEEN '$new_from_date' and '$new_to_date'
		GROUP BY
			v2.comp_id 
		) c ON v.comp_id = c.comp_id
		LEFT JOIN (
		SELECT
			v3.comp_id,
			SUM( v3.debit ) credit_sale 
		FROM
			v_vouchers v3 
		WHERE
			1 = 1 
			AND substr( v3.voucher_id, 3, 2 ) = 'SL' 
			AND v3.cash <> 'Y' 
			and v3.voucher_date BETWEEN '$new_from_date' and '$new_to_date' 
		AND
		IF
			(
				substring( v3.voucher_id, 3, 2 ) IN ( 'SL', 'PL' ),
				substring( v3.voucher_id,- 1 )= 1,
				1 = 1 
			) 
		GROUP BY
			v3.comp_id 
		) c2 ON v.comp_id = c2.comp_id
		LEFT JOIN (
		SELECT
			v4.comp_id,
			SUM( v4.debit ) cash_received 
		FROM
			v_vouchers v4 
		WHERE
			1 = 1 
			AND substr( v4.voucher_id, 3, 2 ) IN ( 'CR', 'JV' ) 
			AND v4.acct_id IN ( '2610000463', '2610000804', '2610000790', '2610000464', '2610000462', '2610001116', '2610000886', '2610000789', '2610001164', '2610001191' ) 
			and v4.voucher_date BETWEEN '$new_from_date' and '$new_to_date'
		GROUP BY
			v4.comp_id 
		) c3 ON v.comp_id = c3.comp_id
		LEFT JOIN (
		SELECT
			v5.comp_id,
			SUM( v5.credit ) cash_payment 
		FROM
			v_vouchers v5 
		WHERE
			1 = 1 
			AND substr( v5.voucher_id, 3, 2 ) IN ( 'CP', 'JV' ) 
			AND v5.acct_id IN ( '2610000463', '2610000804', '2610000790', '2610000464', '2610000462', '2610001116', '2610000886', '2610000789', '2610001164', '2610001191' ) 
			and v5.voucher_date BETWEEN '$new_from_date' and '$new_to_date'
		GROUP BY
			v5.comp_id 
		) c4 ON v.comp_id = c4.comp_id
		LEFT JOIN (
		SELECT
			v6.comp_id,
			SUM( v6.credit ) cash_purchase 
		FROM
			v_vouchers v6 
		WHERE
			1 = 1 
			AND substr( v6.voucher_id, 3, 2 ) = 'PL' 
			AND v6.acct_id IN ( '2610000463', '2610000804', '2610000790', '2610000464', '2610000462', '2610001116', '2610000886', '2610000789', '2610001164', '2610001191' ) 
			and v6.voucher_date BETWEEN '$new_from_date' and '$new_to_date' 
		GROUP BY
			v6.comp_id 
		) c5 ON v.comp_id = c5.comp_id
		LEFT JOIN (
		SELECT
			v7.comp_id,
			SUM( v7.credit ) sale_return 
		FROM
			v_vouchers v7 
		WHERE
			1 = 1 
			AND substr( v7.voucher_id, 3, 2 )= 'RT' 
			AND v7.acct_id IN ( '2610000463', '2610000804', '2610000790', '2610000464', '2610000462', '2610001116', '2610000886', '2610000789', '2610001164', '2610001191' ) 
			and v7.voucher_date BETWEEN '$new_from_date' and '$new_to_date'
		GROUP BY
			v7.comp_id 
		) c6 ON v.comp_id = c6.comp_id
	    
	    
	    	LEFT JOIN (
		SELECT
			v8.comp_id,
			SUM(v8.net_amt) month_cash_sale 
		FROM
			sl_invoice v8
		LEFT JOIN nom n ON v8.acct_id=n.acct_id
		WHERE
			1 = 1 
			AND n.cash = 'Y'  and v8.voucher_date BETWEEN '$curr_month_from_date' and '$new_to_date'
		GROUP BY
			v8.comp_id 
		) c7 ON v.comp_id = c7.comp_id
	    
	    
	    	LEFT JOIN (
		SELECT
			v9.comp_id,
			SUM(v9.net_amt) month_credit_sale 
		FROM
			sl_invoice v9
		LEFT JOIN nom n ON v9.acct_id=n.acct_id
		WHERE
			1 = 1 
			AND n.cash<> 'Y' and v9.voucher_date BETWEEN '$curr_month_from_date' and '$new_to_date'
		GROUP BY
			v9.comp_id 
		) c8 ON v.comp_id = c8.comp_id

	) n 
WHERE n.voucher_date BETWEEN '$new_from_date' and '$new_to_date' and
	n.comp_id NOT IN (
	'CA')";
    $v_result = $dbcon->prepare($v_query);
    $v_result->execute(array());
} catch (PDOException $e) {
    echo "Error : " . $e->getMessage();
}

$sr = "";

while ($report_row = $v_result->fetch(PDO::FETCH_ASSOC)) {
    $sr  += 1;

    $g_amt += $report_row['amt'];

    $day_name = $report_row['day_name'];
    $tot_cash += $report_row['CashSale'];
    $OnlineSale += $report_row['OnlineSale'];
    $CreditSale += $report_row['CreditSale'];

    $row_tot = $report_row['CashSale'] + $report_row['OnlineSale'] + $report_row['CreditSale'];

    $g_row_tot += $row_tot;


    $f_comp_id =  $report_row['comp_id'];



    if($f_comp_id == 'BT')
    {
        $ob = $o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.voucher_date < '$new_from_date' and  v.acct_id = '2610000463') v ", 'bal_amt', ''));


    }

    if($f_comp_id == 'CA')
    {
        $ob = $o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.voucher_date < '$new_from_date'and  v.acct_id = '2610000804') v ", 'bal_amt', ''));


    }

    if($f_comp_id == 'HT')
    {
        $ob = $o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.voucher_date < '$new_from_date' and  v.acct_id = '2610000790') v ", 'bal_amt', ''));


    }

    if($f_comp_id == 'IT')
    {
        $ob = $o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.voucher_date < '$new_from_date' and  v.acct_id = '2610000464') v ", 'bal_amt', ''));


    }

    if($f_comp_id == 'KT')
    {
        $ob = $o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.voucher_date < '$new_from_date' and  v.acct_id = '2610000462') v ", 'bal_amt', ''));


    }


    if($f_comp_id == 'QT')
    {
        $ob = $o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.voucher_date < '$new_from_date' and  v.acct_id = '2610001116') v ", 'bal_amt', ''));


    }

    if($f_comp_id == 'RF')
    {
        $ob = $o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.voucher_date < '$new_from_date' and  v.acct_id = '2610000886') v ", 'bal_amt', ''));


    }

    if($f_comp_id == 'ZT')
    {
        $ob = $o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.voucher_date < '$new_from_date' and  v.acct_id = '2610000789') v ", 'bal_amt', ''));


    }

    if($f_comp_id == 'SB')
    {
        $ob = $o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.voucher_date < '$new_from_date' and  v.acct_id = '2610001164') v ", 'bal_amt', ''));


    }

    if($f_comp_id == 'HO')
    {
        $ob = $o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.voucher_date < '$new_from_date' and  v.acct_id = '2610001191') v ", 'bal_amt', ''));


    }







    $row_tot = $ob + $report_row['cash_sale'] + $report_row['credit_sale']+ $report_row['cash_received'];

    $g_row_tot += $row_tot;


    $cal_cash_in_hand = $ob + $report_row['cash_sale'] + $report_row['cash_received'] - $report_row['cash_payment'] - $report_row['cash_purchase'] - $report_row['sale_return'];


    $row_tot_payment = $report_row['cash_payment'] + $report_row['credit_sale']+ $cal_cash_in_hand + $report_row['cash_purchase'] + $report_row['sale_return'];

    $g_row_tot_pay += $row_tot_payment;


    $g_ob_tot += $ob;

    $g_cash_sale_tot += $report_row['cash_sale'];
    $g_tot_credit_sale += $report_row['credit_sale'];
    $g_tot_cash_rec += $report_row['cash_received'];
    $g_tot_cash_payment += $report_row['cash_payment'];
    $g_tot_cash_purchase += $report_row['cash_purchase'];
    $g_tot_sale_return += $report_row['sale_return'];
    $g_tot_cash_hand += $cal_cash_in_hand;

    $g_cash_month_cash_sale += $report_row['month_cash_sale'];
    $g_tot_month_credit_sale += $report_row['month_credit_sale'];

    $b .=
        '
                    <tr>
                        <td style="width: 7%;" >'.$report_row['comp_id'].'</td>
                        <td style="width: 7%;">'.format_number_pdf($ob,0).'</td>
                        <td style="width: 7%;">'.format_number_pdf($report_row['cash_sale'],0).'</td>
                        <td style="width: 7%;">'.format_number_pdf($report_row['credit_sale'],0).'</td>
                        <td style="width: 7%;">'. format_number_pdf($report_row['cash_received'],0).'</td>
                        <td style="font-weight: bold; width: 8%">'.format_number_pdf($row_tot,0).'</td>

                        <td style="width: 7%;">'.format_number_pdf($report_row['cash_payment'],0).'</td>
                        <td style="width: 7%;">'. format_number_pdf($report_row['credit_sale'],0).'</td>
                        <td style="width: 7%;">'.format_number_pdf($cal_cash_in_hand,0).'</td>
                         <td style="width: 7%;">'.format_number_pdf($report_row['cash_purchase'],0).'</td>
                          <td style="width: 7%;">'.format_number_pdf($report_row['sale_return'],0).'</td>

                        <td style="font-weight: bold; width: 8%">'.format_number_pdf($row_tot_payment,0).'</td>
                         <td  style="width: 7%;">'.format_number_pdf($report_row['month_cash_sale'],0).'</td>
                        <td  style="width: 7%;">'.format_number_pdf($report_row['month_credit_sale'],0).'</td>


                    </tr>';

}



$c .=
    '
                    <tr>
                        <td ><b>Total</b></td>
                    <td ><b>'.format_number_pdf( $g_ob_tot , 0).'</b></td>
                    <td ><b>'.format_number_pdf( $g_cash_sale_tot , 0).'</b></td>
                    <td ><b>'. format_number_pdf( $g_tot_credit_sale , 0).'</b></td>
                    <td ><b>'. format_number_pdf( $g_tot_cash_rec , 0).'</b></td>
                    <td ><b>'. format_number_pdf( $g_row_tot , 0).'</b></td>




                    <td ><b>'. format_number_pdf( $g_tot_cash_payment , 0).'</b></td>
                    <td ><b>'. format_number_pdf( $g_tot_credit_sale , 0).'</b></td>

                    <td ><b>'. format_number_pdf( $g_tot_cash_hand , 0).'</b></td>
                    <td ><b>'. format_number_pdf( $g_tot_cash_purchase , 0).'</b></td>
                    <td ><b>'. format_number_pdf( $g_tot_sale_return , 0).'</b></td>
                    <td ><b>'. format_number_pdf( $g_row_tot_pay , 0).'</b></td>
                     <td ><b>'. format_number_pdf( $g_cash_month_cash_sale , 0).'</b></td>
                      <td ><b>'. format_number_pdf( $g_tot_month_credit_sale , 0).'</b></td>




                    </tr>';

$d = '</tbody>
                            </table>';
$pdf->Cell(5);
$pdf->writeHTML($a.$b.$c.$d, true, false, true, false, '');


$find_comp_name = find_value("v_system","comp_name", "");


/********************************START SEND WHATS APP MESSAGES************************************/

$sms_no = '923214604022';





$from_date = date('d-m-Y');

$dir = "whatsapp/reports/";
if (!file_exists($dir)) {
    mkdir($dir, 0777);
}
$dirPath = "whatsapp/reports/";
if (!file_exists($dirPath)) {
    mkdir($dirPath, 0777);
}
$filename = "whatsapp/reports/" . $find_comp_name.'_'.'Daily_Summary_'. $from_date.'.pdf';


$pdf->Output($filename, 'F');
$f_name = $find_comp_name.'_'.'Daily_Summary_'. $from_date;
$to = $sms_no;
$file_url = 'https://kafeeltraders.com/click/finance/'.$filename;


$curl = curl_init();

curl_setopt_array($curl, array(
    CURLOPT_URL => "https://api.ultramsg.com/instance10452/messages/document",
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_SSL_VERIFYHOST => 0,
    CURLOPT_SSL_VERIFYPEER => 0,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "POST",
    CURLOPT_POSTFIELDS => "token=ncp7ygzt3zcuav15&to=" . $to . "&filename=" . $f_name . "&document=" . $file_url . "&referenceId=&nocache=",
    CURLOPT_HTTPHEADER => array(
        "content-type: application/x-www-form-urlencoded"
    ),
));

$response = curl_exec($curl);
$err = curl_error($curl);





/********************************END SEND WHATS APP MESSAGES************************************/



ob_end_clean();
$pdf->Output($find_comp_name.'-'.'Daily Summary '. $from_date.'.pdf');
