<?php
session_start();
ob_start();
include("include/dbconnect.php");
include("include/functions.php");
require_once ("tcpdf/tcpdf.php");


if($_SESSION['VALID_USER_NAME'] == false)
{
    header("location: login");
}

date_default_timezone_set("Asia/Karachi");
$_SESSION['voucher_type'] = clean_data($_GET['voucher_type']);
$voucher_type = clean_data($_SESSION['voucher_type']);
$comp_id = clean_data($_GET["comp_id"]);
if (empty($comp_id))
    $comp_id = clean_data($_SESSION["comp_id"]);

$year_id = $_GET["year_id"];
if (empty($year_id))
    $year_id = clean_data($_SESSION["year_id"]);

$comp_name = clean_data($_SESSION["COMP_NAME"]);
$phone = clean_data($_SESSION["phone"]);
$address = clean_data($_SESSION["address"]);

$s_date_formt =  find_value('v_system','date_format', '');
$currency_sign = find_value('v_system','currency_sign', '');
$amt_decimals = find_value('v_system','amt_decimals','');
$qty_decimals = find_value('v_system','qty_decimals', '');


$_SESSION['login_page']  = find_value("v_system", "login_page", " ");


$v_id = clean_data($_GET['v_id']);


// Extend the TCPDF class to create custom Header and Footer
class PDF extends TCPDF {

    //Page header
    public function Header()
    {

        include("include/dbconnect.php");
        /*****************START VARIABLES***************/

        $v_id = $_GET['v_id'];
        $comp_id = clean_data($_GET["comp_id"]);
        if (empty($comp_id))
            $comp_id = clean_data($_SESSION["comp_id"]);

        $year_id = $_GET["year_id"];
        if (empty($year_id))
            $year_id = clean_data($_SESSION["year_id"]);
        $address = clean_data($_SESSION["address"]);
        $phone = clean_data($_SESSION["phone"]);
        $comp_name = clean_data($_SESSION["COMP_NAME"]);





    }



    function Footer()
    {




        $font_cal = TCPDF_FONTS::addTTFfont('tcpdf/fonts/Calibri/Calibri Regular.ttf', 'TrueTypeUnicode', '', 32);

        //$this->Line(0,162,120,162);
        //$this->SetY( 30 );

        $this->SetFont( $font_cal, '', 10 );

        $this->Ln(-2);
        $this->SetFont( $font_cal, '', 8 );
        $this->Cell(0,0,''. "Purchased Goods Will Not Be Returned Or Exchanged.",0,0,'C');



        if($_SESSION['login_page'] == 'login-at') {
            $this->Ln(3);

            $this->SetFont($font_cal, 'B', 8);
            $this->Cell(0, 0, '' . "THE ABLE STORE", 0, 0, 'C');
            $this->Ln(3);
            $this->SetFont($font_cal, 'B', 8);
            $this->Cell(0, 0, '' . "THANK YOU", 0, 0, 'C');
        }







    }





}




// create new PDF document
$pdf = new PDF(PDF_PAGE_ORIENTATION, PDF_UNIT, 'PDF_PAGE_FORMAT', true, 'UTF-8', false);



$pdf->SetPrintHeader(true);
$pdf->SetPrintFooter(true);

//$pdf->AddPage('P',  'in', [5.83,8.27]);
$pdf->AddPage('P', 'A5');

//$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
$pdf->SetAutoPageBreak(true, 10);

$pdf->setFontSubsetting(false);
$font_noori_urdu = TCPDF_FONTS::addTTFfont('tcpdf/fonts/PaktRegular.ttf', 'TrueTypeUnicode', '', 32);

$pdf->SetFont('paktypenaskhbasicsa', '', 10, '', false);
$font_cal = TCPDF_FONTS::addTTFfont('tcpdf/fonts/Calibri/Calibri Regular.ttf', 'TrueTypeUnicode', '', 32);
$font_cal_bold = TCPDF_FONTS::addTTFfont('tcpdf/fonts/Calibri/Calibri Bold.TTF', 'TrueTypeUnicode', '', 32);

$arial_fontname = TCPDF_FONTS::addTTFfont('tcpdf/fonts/ARIALBD.TTF', 'TrueTypeUnicode', '', 32);

$able_font = TCPDF_FONTS::addTTFfont('tcpdf/fonts/pantonblackitaliccaps.ttf', 'TrueTypeUnicode', '', 32);


$emp_id = clean_data($_SESSION["VALID_USER_NAME"]);


$and = '';
$and .= " AND v.voucher_id = '$v_id'";
$and .= " and v.comp_id =  '$comp_id' ";
$and .= " and v.year_id =  '$year_id' ";


try {
    $sl_detail_query = "SELECT v.acct_id, v.voucher_id, v.bill_no, v.voucher_date, c.comp_name, c.add_line1 comp_address,c.phone,c.email,
                              c.stax_no, c.ntn, p.acct_name party_name, p.address add_line1, c.phone c_phone, 
                                p.phone, v.disc_amt,v.emp_id,
	v.dc_amt,
	v.net_amt,
	v.adv_amt,
	v.net_payable,
       v.particulars,
       date_format(v.post_date, \"%h:%i %p\") post_date,
       p2.acct_name bill_type_name,
       v.customer_cash,
       v.return_cash,
         v.adv_amt,
       v.b_adv_amt
       
       
                        FROM sl_invoice v 
                        LEFT JOIN company c ON c.comp_id = v.comp_id
                        LEFT JOIN v_party p ON p.acct_id = v.acct_id
                        LEFT JOIN v_party p2 ON p2.acct_id = v.bill_type
                        WHERE 1=1  $and
                        ORDER BY v.bill_no
                       ";
    $sl_detail_result = $dbcon->prepare($sl_detail_query);
    $sl_detail_result->execute(array());
} catch (PDOException $e) {
    echo "Error : " . $e->getMessage();
}

$num_rows = $sl_detail_result->rowCount();
$_SESSION["num_rows"] = $num_rows;
$rowm = $sl_detail_result->fetch(PDO::FETCH_ASSOC);
$voucherId = $rowm['voucher_id'];
$acct_id = $rowm['acct_id'];


if($acct_id == '2610000001')
{
    $p_type = 'Cash';
}
else
{
    $p_type = 'Credit';
}

$login_page  = find_value("v_system", "login_page", " ");
if($login_page == 'login-at')
{

    $image_file = 'assets/img/logo/at/at_logo.png';
    $pdf->Image($image_file, '', '', 30, '30', 'png', '', 'T', false, 300, '', false, false, 0, false, false, false);


}
if($login_page == 'login-hm')
{

    $image_file = 'assets/img/logo/hm/logo_1.png';
    $pdf->Image($image_file, '', '', 30, '30', 'png', '', 'T', false, 300, '', false, false, 0, false, false, false);


}

if($login_page == 'login-arkt')
{

    $image_file = 'assets/img/logo/arkt/logo.png';
    $pdf->Image($image_file, '', '', 30, '30', 'png', '', 'T', false, 300, '', false, false, 0, false, false, false);


}


/* $image_file = 'assets/img/logo/at/at_logo.png';
 $pdf->Image($image_file, '', '', 30, '30', 'png', '', 'T', false, 300, '', false, false, 0, false, false, false);*/


$add = find_value("company", "add_line1", " and comp_id = '$comp_id'");
$phone = find_value("company", "phone", " and comp_id = '$comp_id'");
$detail_one = find_value("company", "detail_one", " and comp_id = '$comp_id'");
$detail_two = find_value("company", "detail_two", " and comp_id = '$comp_id'");
$detail_three = find_value("company", "detail_three", " and comp_id = '$comp_id'");


$pdf->Ln(2);

if($login_page == 'login-at')
{

    $pdf->SetFont($able_font, 'B', 30, '', false);
    $pdf->writeHTMLCell(0, 0, '35', '', $comp_name, 0, 0, 0, '', 'C', true);

    $pdf->Ln(7);
    $pdf->SetFont($able_font, 'B', 12, '', false);
    $pdf->writeHTMLCell(0, 0, '40', '', $detail_one, 0, 0, 0, '', 'C', true);



    /*$pdf->SetFont($font_cal, '', 11, '', false);
    $pdf->Ln(4);
    $pdf->writeHTMLCell(0, 0, '40', '', $detail_two, 0, 0, 0, '', 'C', true);


    $pdf->SetFont($font_cal, '', 11, '', false);
    $pdf->Ln(4);
    $pdf->writeHTMLCell(0, 0, '30', '', $detail_three, 0, 0, 0, '', 'C', true);*/
}
else
{
    $pdf->SetFont($font_cal, 'B', 30, '', false);
    $pdf->writeHTMLCell(0, 0, '', '', $comp_name, 0, 0, 0, '', 'C', true);
}

$pdf->Ln(7);
$pdf->SetFont($font_cal, 'B', 8, '', false);
$pdf->writeHTMLCell(0, 0, '20', '', $add, 0, 0, 0, '', 'C', true);

$pdf->Ln(4);
$pdf->SetFont($font_cal, '', 11, '', false);
$pdf->writeHTMLCell(0, 0, '30', '', $phone, 0, 0, 0, '', 'C', true);



$pdf->Ln(5);

$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(20, 0, '12', '', 'Invoice#', 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(30, 0, '40', '', $rowm['voucher_id'], 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(30, 0, '85', '', 'Prepaired By:', 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(30, 0, '110', '', $emp_id, 0, 0, 0, '', 'C', true);


$pdf->Ln(7);


$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(20, 0, '13', '', 'DateTime:', 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(50, 0, '40', '', format_date($rowm['voucher_date']). ' '.  $rowm['post_date'] , 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(30, 0, '86', '', 'Payment Type:', 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(30, 0, '110', '', $p_type, 0, 0, 0, '', 'C', true);


$pdf->Ln(-3);


$pdf->SetLineStyle(array('width' => 0.3, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(0, 0, 0)));
//$pdf->Cell(130, 0, '', 'B', '', 'L', '', 0);
$pdf->writeHTMLCell(0, 0, '10', '', '', 'B', 0, 0, '', 'C', true);


$pdf->Ln(14);


$pdf->SetFont($font_cal, '', 9, '', false);

$pdf->writeHTMLCell(25, 5, '', '', 'Customer Name:', 0, 0, 0, '10', 'L', true);

$pdf->SetFont($font_cal, 'B', 9, '', false);
$pdf->writeHTMLCell(90, 2, '', '', $rowm['party_name'], 0, 0, 0, '10', 'L', true);



$pdf->Ln(12);

$pdf->SetFont($font_cal, 'B', 10, '', false);


$pdf->Cell(45, 7, 'Description', '1', 0, 'L', '');
$pdf->Cell(38, 7, 'Note', '1', 0, 'L', '');
$pdf->Cell(12, 7, 'Qty', '1', 0, 'L', '');
$pdf->Cell(15, 7, 'Price', '1', 0, 'L', '');
$pdf->Cell(18, 7, 'Amount', '1', 0, 'L', '');
$pdf->Ln(7);
$pdf->SetFont($font_cal, '', 8);


$and = " AND d.voucher_id = '$v_id'";
$and .= " AND d.comp_id = '$comp_id'";
$and .= " and d.year_id =  '$year_id' ";


try {
    $vd_query = "SELECT
	d.stock_code,
	d.particulars,
	d.qty,
	d.rate,
	d.voucher_id,
	i.description,
	d.qty*d.rate ex_value,
	d.itemtot,
	d.lineitem,
	c.comp_name,
	d.comp_id,
	d.discp,
       ifnull(t.type_name,'') brand_name,
     ifnull(ct.cat_name,'') cat_name ,
     d.particulars
	
 	FROM sl_invoice v 
 	LEFT JOIN sl_invoicedet d ON v.voucher_id = d.voucher_id and v.comp_id = d.comp_id and v.year_id=d.year_id
	LEFT JOIN item i ON d.stock_code = i.stock_code
 	    LEFT JOIN prod_type t ON i.type_id = t.type_id
LEFT JOIN prod_cat ct ON i.cat_id = ct.cat_id  
	LEFT JOIN company c ON c.comp_id = v.comp_id  
 	
 	WHERE 1=1 $and ORDER BY d.lineitem/1";
    $vd_result = $dbcon->prepare($vd_query);
    $vd_result->execute(array());
} catch (PDOException $e) {
    echo "Error : " . $e->getMessage();
}


$sr = 0;
$g_tot = 0;
$tot_qty = 0;
$amount_tot = 0;
$qty_tot = 0;
while ($rd_row = $vd_result->fetch(PDO::FETCH_ASSOC)) {

    $g_tot += $rd_row['amount'];
    $tot_qty += $rd_row['qty'];
    $v = $rd_row['voucher_id'];
    $qty_tot += $rd_row['qty'];
    $amount_tot += $rd_row['itemtot'];

    $sr += 1;
    $pdf->SetFont($font_cal, '', 9);

    $pdf->writeHTMLCell(45, 9, '', '', $rd_row['description']. '/' .$rd_row['cat_name'] . '/' .$rd_row['brand_name'], '1', 0, 0, '10', 'L', true);
    $pdf->writeHTMLCell(38, 9, '', '', $rd_row['particulars'], '1', 0, 0, '10', 'L', true);
    $pdf->writeHTMLCell(12, 9, '', '', format_number($rd_row['qty'], 2), '1', 0, 0, '10', 'L', true);
    $pdf->writeHTMLCell(15, 9, '', '', format_number($rd_row['rate'], 2), '1', 0, 0, '10', 'L', true);
    $pdf->writeHTMLCell(18, 9, '', '', format_number($rd_row['itemtot'], 2), '1', 0, 0, '10', 'L', true);

    $pdf->Ln(9);
}


$pdf->Ln(2);
$party_acct_id = $rowm['acct_id'];
$acct_id = $rowm['acct_id'];

$net_payable = $rowm['net_payable'];

$net_amt = $rowm['net_amt'];
$v_date =  $rowm['voucher_date'];
$p_bal = find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                     FROM v_vouchers v where v.acct_id = '$party_acct_id' and v.voucher_date < '$v_date'  ) v "  , 'bal_amt', '' );




$p_bal_cur = find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                     FROM v_vouchers v where v.acct_id = '$party_acct_id'  ) v "  , 'bal_amt', '' );




$o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.acct_id = '$acct_id' AND acct_id not in ('2610000462', '2610000463', '2610000464')) v ", 'bal_amt', ''));
$sub_g_tot = $rowm['net_amt'] + $rowm['disc_amt'];
$dic_amt = $rowm['disc_amt'];
$final_total = $sub_g_tot - $dic_amt;

$tot_paid = $rowm['adv_amt'] + $rowm['b_adv_amt'];

$balance = $o_bal - $net_payable;

$total_bal = $net_payable + $balance;


if($acct_id != '2610000001')
{
    $tot_bal = $final_total - $tot_paid + $p_bal ;
    $p_bal_tot = $p_bal;
}






$html = '<table border="1" cellspacing="0" cellpadding="3" style="width: 100%; ">
       <tr>

        <td style="width: 65%; text-align: left; ">Subtotal:</td>
         <td style="width: 10%; text-align: left; ">' . number_format($tot_qty, 2) . '</td>
        <td style="width: 25%; text-align: right; ">' . number_format($amount_tot, 2) . '</td>

  </tr>
  
   <tr>

        <td style="width: 85%; text-align: left; ">Discount:</td>
        <td style="width: 15%; text-align: right; ">' . number_format($dic_amt, 2) . '</td>

  </tr>
  
   
  
   <tr>

        <td style="width: 85%; text-align: left; ">Total:</td>
        <td style="width: 15%; text-align: right; ">' . number_format($net_amt, 2) . '</td>

  </tr>
  
  <tr>

        <td style="width: 85%; text-align: left; ">Payment:</td>
        <td style="width: 15%; text-align: right; ">' . number_format($tot_paid, 2) . '</td>

  </tr>
  
  
   <tr>

        <td style="width: 85%; text-align: left; ">Previous Balance:</td>
        <td style="width: 15%; text-align: right; ">' . number_format($p_bal_tot, 2) . '</td>

  </tr>
  
 
  
  
   <tr>

        <td style="width: 85%; text-align: left; ">Balance:</td>
        <td style="width: 15%; text-align: right; ">' . number_format($tot_bal, 2) . '</td>

  </tr>
  
  
  

    </table>';
$pdf->SetFont($font_cal, 'B', 9);
$pdf->writeHTML($html, true, false, true, false, '');

ob_end_clean();
$pdf->Output();
