<?php
session_start();
ob_start();
include("include/dbconnect.php");
include("include/functions.php");
require_once ("tcpdf/tcpdf.php");


if($_SESSION['VALID_USER_NAME'] == false)
{
    header("location: login");
}

date_default_timezone_set("Asia/Karachi");
$_SESSION['voucher_type'] = clean_data($_GET['voucher_type']);
$voucher_type = clean_data($_SESSION['voucher_type']);

$comp_id = clean_data($_GET["comp_id"]);
if (empty($comp_id))
    $comp_id = clean_data($_SESSION["comp_id"]);

$year_id = $_GET["year_id"];
if (empty($year_id))
    $year_id = clean_data($_SESSION["year_id"]);


$comp_name = clean_data($_SESSION["COMP_NAME"]);
$phone = clean_data($_SESSION["phone"]);
$address = clean_data($_SESSION["address"]);

$s_date_formt =  find_value('v_system','date_format', '');
$currency_sign = find_value('v_system','currency_sign', '');
$amt_decimals = find_value('v_system','amt_decimals','');
$qty_decimals = find_value('v_system','qty_decimals', '');

$v_id = clean_data($_GET['v_id']);


// Extend the TCPDF class to create custom Header and Footer
class PDF extends TCPDF {

    //Page header
    public function Header()
    {

        include("include/dbconnect.php");
        /*****************START VARIABLES***************/

        $v_id = $_GET['v_id'];

        $comp_id = clean_data($_GET["comp_id"]);
        if (empty($comp_id))
            $comp_id = clean_data($_SESSION["comp_id"]);

        $year_id = $_GET["year_id"];
        if (empty($year_id))
            $year_id = clean_data($_SESSION["year_id"]);

        $address = clean_data($_SESSION["address"]);
        $phone = clean_data($_SESSION["phone"]);
        $comp_name = clean_data($_SESSION["COMP_NAME"]);





    }



    function Footer()
    {


        $comp_name = clean_data($_SESSION["COMP_NAME"]);

        $font_cal = TCPDF_FONTS::addTTFfont('tcpdf/fonts/Calibri/Calibri Regular.ttf', 'TrueTypeUnicode', '', 32);

        //$this->Line(0,162,120,162);
        //$this->SetY( 30 );

        $this->SetFont($font_cal, '', 10);

        $this->Ln(-2);
        $this->SetFont($font_cal, '', 8);
        //$this->Cell(0, 0, '' . "Purchased Goods Will Not Be Returned Or Exchanged.", 0, 0, 'C');


        $this->Ln(3);
        $this->SetFont($font_cal, 'B', 8);
        $this->Cell(0, 0, '' .$comp_name, 0, 0, 'C');
        $this->Ln(3);
        $this->SetFont($font_cal, 'B', 8);
        $this->Cell(0, 0, '' . "THANK YOU", 0, 0, 'C');








    }





}




// create new PDF document
$pdf = new PDF(PDF_PAGE_ORIENTATION, PDF_UNIT, 'PDF_PAGE_FORMAT', true, 'UTF-8', false);



$pdf->SetPrintHeader(true);
$pdf->SetPrintFooter(true);

//$pdf->AddPage('P',  'in', [5.83,8.27]);
$pdf->AddPage('P', 'A4');

//$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
$pdf->SetAutoPageBreak(PDF_MARGIN_FOOTER);

$pdf->setFontSubsetting(false);
$font_noori_urdu = TCPDF_FONTS::addTTFfont('tcpdf/fonts/PaktRegular.ttf', 'TrueTypeUnicode', '', 32);

$pdf->SetFont('paktypenaskhbasicsa', '', 10, '', false);
$font_cal = TCPDF_FONTS::addTTFfont('tcpdf/fonts/Calibri/Calibri Regular.ttf', 'TrueTypeUnicode', '', 32);
$font_cal_bold = TCPDF_FONTS::addTTFfont('tcpdf/fonts/Calibri/Calibri Bold.TTF', 'TrueTypeUnicode', '', 32);

$arial_fontname = TCPDF_FONTS::addTTFfont('tcpdf/fonts/ARIALBD.TTF', 'TrueTypeUnicode', '', 32);


$emp_id = clean_data($_SESSION["VALID_USER_NAME"]);


$and = '';
$and .= " AND v.voucher_id = '$v_id'";
$and .= " and v.comp_id =  '$comp_id' ";
$and .= " and v.year_id =  '$year_id' ";


try {
    $sl_detail_query = "SELECT v.acct_id, v.voucher_id, v.bill_no, v.voucher_date, c.comp_name, c.add_line1 comp_address,c.phone,c.email,
                              c.stax_no, c.ntn, p.acct_name party_name, p.address add_line1,  c.phone c_phone, 
                                p.phone, v.disc_amt,v.emp_id,
	v.dc_amt,
	v.net_amt,
	v.adv_amt,
	v.net_payable,
       v.particulars,
       date_format(v.post_date, \"%h:%i %p\") post_date,
       p2.acct_name bill_type_name,
       v.customer_cash,
       v.return_cash,
       v.emp_id,
       v.customer_name,
       v.customer_phone
       
       
                        FROM sl_invoice v 
                        LEFT JOIN company c ON c.comp_id = v.comp_id
                        LEFT JOIN v_party p ON p.acct_id = v.acct_id
                        LEFT JOIN v_party p2 ON p2.acct_id = v.bill_type
                        WHERE 1=1  $and
                        ORDER BY v.bill_no
                       ";
    $sl_detail_result = $dbcon->prepare($sl_detail_query);
    $sl_detail_result->execute(array());
} catch (PDOException $e) {
    echo "Error : " . $e->getMessage();
}




$num_rows = $sl_detail_result->rowCount();
$_SESSION["num_rows"] = $num_rows;
$rowm = $sl_detail_result->fetch(PDO::FETCH_ASSOC);
$voucherId = $rowm['voucher_id'];
$particulars = $rowm['particulars'];
$acct_id = $rowm['acct_id'];
$f_emp_id = $rowm["emp_id"];

if($acct_id == '2710000001')
{
    $p_type = 'Cash';
}
else
{
    $p_type = 'Credit';
}



    // Logo
    $image_file = 'images/kt_logo_final.png';
    //$pdf->Image($image_file, 12, 5, 30, '30', 'png', '', 'T', false, 300, '', false, false, 0, false, false, false);







$add = find_value("company", "add_line1", " and comp_id = '$comp_id'");
$phone = find_value("company", "phone", " and comp_id = '$comp_id'");
$mobile = find_value("company", "mobile", " and comp_id = '$comp_id'");
$detail_one = find_value("company", "detail_one", " and comp_id = '$comp_id'");
$detail_two = find_value("company", "detail_two", " and comp_id = '$comp_id'");
$detail_three = find_value("company", "detail_three", " and comp_id = '$comp_id'");

$pdf->SetFont($font_cal, 'B', 30, '', false);



$pdf->writeHTMLCell(0, 0, '10', '', $comp_name, 0, 0, 0, '', 'C', true);

$pdf->Ln(10);

$pdf->SetFont($font_cal, 'B', 12, '', false);
$pdf->writeHTMLCell(0, 0, '', '', $add, 0, 0, 0, '', 'C', true);

$pdf->Ln(8);
$pdf->SetFont($font_cal, 'B', 14, '', false);
$pdf->writeHTMLCell(0, 0, '', '', $phone.', '.$mobile, 0, 0, 0, '', 'C', true);



$pdf->Ln(11);

$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(20, 0, '12', '', 'Invoice#', 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(30, 0, '40', '', $rowm['voucher_id'], 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(30, 0, '140', '', 'Prepared By:', 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(30, 0, '170', '', $f_emp_id, 0, 0, 0, '', 'C', true);


$pdf->Ln(7);


$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(20, 0, '13', '', 'DateTime:', 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(50, 0, '40', '', format_date($rowm['voucher_date']). ' '.  $rowm['post_date'] , 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(30, 0, '140', '', 'Payment Type:', 0, 0, 0, '', 'C', true);
$pdf->SetFont($font_cal, '', 12, '', false);
$pdf->writeHTMLCell(30, 0, '170', '', $p_type, 0, 0, 0, '', 'C', true);


$pdf->Ln(-3);


$pdf->SetLineStyle(array('width' => 0.3, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(0, 0, 0)));
//$pdf->Cell(130, 0, '', 'B', '', 'L', '', 0);
$pdf->writeHTMLCell(0, 0, '10', '', '', 'B', 0, 0, '', 'C', true);


$pdf->Ln(10);

$customer_name = $rowm['customer_name'];
$customer_phone = $rowm['customer_phone'];

if($acct_id == '2710000001')
{
    $acct_name = 'Walk in Customer';
    if($customer_name != '')
    {
        $acct_name = 'Walk in Customer';
        $acct_name_2 = $customer_name . '-'. $customer_phone;
    }

}
else
{
    $acct_name = $rowm['party_name'] .' - ' . $rowm['phone'];
}




$pdf->SetFont($font_cal, '', 12, '', false);

$pdf->writeHTMLCell(35, 0, '', '', 'Customer Name:', 0, 0, 0, '', 'L', true);

$pdf->SetFont($font_cal, 'B', 12, '', false);
$pdf->writeHTMLCell(0, 0, '', '', $acct_name, 0, 0, 0, '', 'L', true);
$pdf->Ln(5);
$pdf->writeHTMLCell(65, 0, '', '', $acct_name_2, 0, 0, 0, '', 'L', true);


$pdf->Ln(12);

$pdf->SetFont($font_cal, 'B', 10, '', false);


$pdf->Cell(125, 7, 'Description', '1', 0, 'L', '');
$pdf->Cell(15, 7, 'Qty', '1', 0, 'L', '');
$pdf->Cell(25, 7, 'Price', '1', 0, 'L', '');
$pdf->Cell(25, 7, 'Amount', '1', 0, 'L', '');
$pdf->Ln(7);
$pdf->SetFont($font_cal, '', 8);


$and = " AND d.voucher_id = '$v_id'";
$and .= " AND d.comp_id = '$comp_id'";
$and .= " and d.year_id =  '$year_id' ";


try {
    $vd_query = "SELECT
	d.stock_code,
	d.particulars,
	d.qty,
	d.rate,
	d.voucher_id,
	i.description,
	d.qty*d.rate ex_value,
	d.itemtot,
	d.lineitem,
	c.comp_name,
	d.comp_id,
	d.discp,
    ifnull(t.type_name,'') brand_name,
     ifnull(ct.cat_name,'') cat_name ,
     v.dc_amt
	
 	FROM sl_invoice v 
 	LEFT JOIN sl_invoicedet d ON v.voucher_id = d.voucher_id and v.comp_id = d.comp_id and v.year_id=d.year_id
	LEFT JOIN item i ON d.stock_code = i.stock_code
LEFT JOIN prod_type t ON i.type_id = t.type_id
 	 LEFT JOIN prod_cat ct ON i.cat_id = ct.cat_id  
	LEFT JOIN company c ON c.comp_id = v.comp_id  
 	
 	WHERE 1=1 $and ORDER BY d.lineitem/1";
    $vd_result = $dbcon->prepare($vd_query);
    $vd_result->execute(array());
} catch (PDOException $e) {
    echo "Error : " . $e->getMessage();
}


$sr = 0;
$g_tot = 0;
$tot_qty = 0;
$amount_tot = 0;
$qty_tot = 0;
while ($rd_row = $vd_result->fetch(PDO::FETCH_ASSOC)) {

    $g_tot += $rd_row['amount'];
    $tot_qty += $rd_row['qty'];
    $v = $rd_row['voucher_id'];
    $qty_tot += $rd_row['qty'];
    $amount_tot += $rd_row['itemtot'];

    $sr += 1;
    $pdf->SetFont($font_cal, '', 10);
    $pdf->Cell(125, 7, $rd_row['description'], '1', 0, 'L');
    $pdf->Cell(15, 7, format_number($rd_row['qty'], 2), '1', '', 'L');
    $pdf->Cell(25, 7, format_number($rd_row['rate'], 2), '1', '', 'R');
    $pdf->Cell(25, 7, format_number($rd_row['itemtot'], 2), '1', 0, 'R');
    $pdf->Ln(7);
}


$pdf->Ln(2);

$acct_id = $rowm['acct_id'];

$net_payable = $rowm['net_payable'];

$o_bal = round(find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                  FROM v_vouchers v where  v.acct_id = '$acct_id' ) v ", 'bal_amt', ''));
$balance = $o_bal - $net_payable;

$total_bal = $net_payable + $balance;
$tot_paid = $rowm['adv_amt'] + $rowm['b_adv_amt'];

$sub_g_tot = $rowm['net_amt'] + $rowm['disc_amt'];
$dic_amt = $rowm['disc_amt'];
$freight = $rowm['dc_amt'];
$final_total = $sub_g_tot - $dic_amt;
$party_acct_id = $rowm['acct_id'];





$p_bal_cur = find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                     FROM v_vouchers v where v.acct_id = '$party_acct_id'  ) v "  , 'bal_amt', '' );



if($acct_id == '2710000001')
{

    $p_bal = 0;

    $tot_bal = 0 ;
    $p_bal_tot = 0;
    $balance = $o_bal - $net_payable;

    $total_bal = $net_payable;
}

else
{
    $p_bal = find_value("(SELECT sum(ifnull(v.debit,0) - ifnull(v.credit,0)) bal_amt
                                     FROM v_vouchers v where v.acct_id = '$party_acct_id'  ) v "  , 'bal_amt', '' );



    $tot_bal = $p_bal_cur ;

    $p_bal_tot = 0;
    if($p_bal != 0.00)
    {
        $p_bal_tot = $p_bal - $final_total;
    }
    if($o_bal != 0.00)
    {
        $balance = $o_bal - $net_payable;
        $total_bal = $net_payable + $balance;

    }
    else
    {
        $total_bal = $net_payable;
    }




}










$html = '<table border="1" cellspacing="0" cellpadding="3" style="width: 100%; ">
       <tr>

        <td style="width: 65%; text-align: left; ">Subtotal:</td>
         <td style="width: 12%; text-align: left; ">' . number_format($tot_qty, 2) . '</td>
        <td style="width: 23%; text-align: right; ">' . number_format($amount_tot, 2) . '</td>

  </tr>
  
  
      <tr>

        <td style="width: 85%; text-align: left; ">Discount:</td>
        <td style="width: 15%; text-align: right; ">' . number_format($dic_amt, 2) . '</td>

  </tr>
  
  

  
  
      <tr>

        <td style="width: 85%; text-align: left; ">Freight:</td>
        <td style="width: 15%; text-align: right; ">' . number_format($freight, 2) . '</td>

  </tr>
  
  
  
  
    <tr>

        <td style="width: 85%; text-align: left; ">Previous Balance:</td>
        <td style="width: 15%; text-align: right; ">' . number_format($p_bal_tot, 2) . '</td>

  </tr>
  
   <tr>

        <td style="width: 85%; text-align: left; ">Total:</td>
        <td style="width: 15%; text-align: right; ">' . number_format($total_bal, 2) . '</td>

  </tr>
  
   <tr>

        <td style="width: 85%; text-align: left; ">Payment:</td>
        <td style="width: 15%; text-align: right; ">' . number_format($tot_paid, 2) . '</td>

  </tr>
  
  
   <tr>

        <td style="width: 85%; text-align: left;" >Balance:</td>
       <td style="width: 15%; text-align: right; ">' . number_format($tot_bal, 2) . '</td>

  </tr>

    </table>';
$pdf->SetFont($font_cal, 'B', 9);
$pdf->writeHTML($html, true, false, true, false, '');




$pdf->SetFont($font_cal, 'B', 10, '', false);


$html_t = '';
$html_t .= 'Note:';
//$html_t .= '<br><br>';
//$html_t .= '1-The Invoice is Inclusive of all Taxes.';
$html_t .= '<br>';
$html_t .= $particulars;
$html_t .= '<br><br>';


$pdf->writeHTMLCell(191, 10, '', '', $html_t, 1, 1, 0, '10', 'L', true);



ob_end_clean();
$pdf->Output('Sale Invoice-'. $rowm['party_name'].'.pdf', 'I');
