<?php
session_start();
include("../include/dbconnect.php");
include("../include/functions.php");
//include("../include/sms_function.php");



/***************** START ADD NEW CATEGORY*********************/
if ($_POST['action'] == "add_cat") {

    $cat_id = clean_data($_POST['acct_id']);
    $cat_name = clean_data($_POST['acct_name']);
    $n_acct_id = clean_data($_POST['n_acct_id']);

    try {
        $s_query = "INSERT INTO prod_cat (cat_id, cat_name, acct_id) VALUES (?, ?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($cat_id, $cat_name, $n_acct_id));
    } catch (PDOException $e) {
        echo "Error : " . $e->getMessage();
    }
}
/***************** END ADD NEW CATEGORY*********************/

/***************** START ADD NEW NEWS*********************/
if ($_POST['action'] == "add_news") {
    $post_date = clean_data($_POST['post_date']);
    $exp_date = clean_data($_POST['exp_date']);
    $news = clean_data($_POST['news']);
    $comp_id = clean_data($_POST['comp_id']);



    try {
        $s_query = "INSERT INTO announcement (announcement, post_date, expiry_date, comp_id)VALUES (?, ?, ?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($news, $post_date, $exp_date, $comp_id ));
    } catch (PDOException $e) {
        echo "Error : " . $e->getMessage();
    }


}
/***************** END ADD NEW NEWS*********************/


/***************** START EDIT NEWS*********************/
if ($_POST['action'] == "edit_news") {
    $post_date = clean_data($_POST['post_date']);
    $exp_date = clean_data($_POST['exp_date']);
    $news = clean_data($_POST['news']);
    $hd_id = clean_data($_POST['hd_id']);


    try {

        $s_query = "UPDATE announcement SET announcement = ?, post_date = ?, expiry_date = ? 
			WHERE  id = ?";

        $results = $dbcon->prepare($s_query);
        $results->execute(array($news, $post_date, $exp_date, $hd_id));
    } catch (PDOException $e) {
        echo "Error : " . $e->getMessage();
    }


}
/***************** END EDIT NEWS*********************/

/***************** START ADD NEW COLOR*********************/
if ($_POST['action'] == "add_color") {
    $color_id = clean_data(strtoupper($_POST['color_id']));
    $color_name = clean_data(strtoupper($_POST['color_name']));

    try
    {
        $s_query =  "INSERT INTO color (color_id, description)VALUES (?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($color_id, $color_name));
    }
    catch(PDOException $e)
    {
        echo "Error : ". $e->getMessage();
    }
}
/***************** END ADD NEW COLOR*********************/

/***************** START ADD NEW SALE PERSON*********************/
if ($_POST['action'] == "add_sp") {
    $acct_id = clean_data(strtoupper($_POST['acct_id']));
    $acct_name = clean_data(strtoupper($_POST['acct_name']));
    $comp_id = clean_data(strtoupper($_POST['comp_id']));

    try
    {
        $s_query =  "INSERT INTO sp (acct_id, acct_name, comp_id)
VALUES (?, ?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($acct_id, $acct_name, $comp_id));
    }
    catch(PDOException $e)
    {
        echo "Error : ". $e->getMessage();
    }

}
/***************** END ADD NEW SALE PERSON*********************/

/***************** START ADD NEW ITEM*********************/
if ($_POST['action'] == "add_item") {
    $acct_id = clean_data($_POST['acct_id']);
    $acct_name = ($_POST['acct_name']);
    $o_qty = clean_data($_POST['o_qty']);
    $s_rate = clean_data($_POST['s_rate']);
    $p_rate = clean_data($_POST['p_rate']);
    $staxp = clean_data($_POST['staxp']);
    $cat_id = clean_data($_POST['cat_id']);
    $type_id = clean_data($_POST['type_id']);
    $party_stock_code = clean_data($_POST['party_stock_code']);
    $unit_name = clean_data($_POST['unit_name']);
    $specs = clean_data($_POST['specs']);
    $mol = clean_data($_POST['mol']);
    $mol_qty = clean_data($_POST['mol_qty']);
    $p_acct_id = clean_data($_POST['p_acct_id']);
    $di_no = clean_data($_POST['di_no']);
    $part_no = clean_data($_POST['part_no']);
    $item_no = clean_data($_POST['item_no']);
    $po_no = clean_data($_POST['po_no']);
    $dealer_rate = clean_data($_POST['dealer_rate']);
    $msrp = clean_data($_POST['msrp']);
    $imp_exp = clean_data($_POST['imp_exp']);

    if($mol == 'on')
    {
        $new_mol = 'Y';
    }
    else{
        $new_mol = 'N';
    }

    try
    {
        $s_query =  "INSERT INTO item (stock_code, description, o_qty, s_rate, p_rate, staxp, cat_id, type_id, party_stock_code, unit, specs, mol, mol_qty,dealer_rate, msrp, imp_exp)
                     VALUES (?, ?, ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ? , ?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($acct_id, $acct_name, $o_qty, $s_rate, $p_rate, $staxp, $cat_id, $type_id, $party_stock_code, $unit_name, $specs, $new_mol, $mol_qty, $dealer_rate, $msrp, $imp_exp));
    }
    catch(PDOException $e)
    {
        echo "Error : ". $e->getMessage();
    }

    if(isset($p_acct_id)) {

        try {
            $s_query = "INSERT INTO item_party (acct_id, stock_code, part_no, item_no, po_no, di_no, rate)
VALUES (?, ?, ?, ?, ?, ?, ?)";
            $results = $dbcon->prepare($s_query);
            $results->execute(array($p_acct_id, $acct_name, $part_no, $item_no, $po_no, $di_no, $s_rate));
        } catch (PDOException $e) {
            echo "Error : " . $e->getMessage();
        }
    }
}
/***************** END ADD NEW ITEM*********************/




/***************** START ADD NEW ITEM IM*********************/
if ($_POST['action'] == "add_item_im") {
    $acct_id = clean_data($_POST['acct_id']);
    $acct_name = addslashes($_POST['acct_name']);
    $s_rate = clean_data($_POST['s_rate']);
    $staxp = clean_data($_POST['staxp']);
    $sedp = clean_data($_POST['sedp']);
    $p_acct_id = clean_data($_POST['p_acct_id']);
    $di_no = clean_data($_POST['di_no']);
    $part_no = clean_data($_POST['part_no']);
    $item_no = clean_data($_POST['item_no']);
    $po_no = clean_data($_POST['po_no']);

    try
    {
        $s_query =  "INSERT INTO item (stock_code, description, s_rate, staxp, sedp)
VALUES (?, ?, ?, ?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($acct_id, $acct_name, $s_rate, $staxp, $sedp));
    }
    catch(PDOException $e)
    {
        echo "Error : ". $e->getMessage();
    }

        try {
            $s_query = "INSERT INTO item_party (acct_id, stock_code, part_no, item_no, po_no, di_no, rate)
VALUES (?, ?, ?, ?, ?, ?, ?)";
            $results = $dbcon->prepare($s_query);
            $results->execute(array($p_acct_id, $acct_name, $part_no, $item_no, $po_no, $di_no, $s_rate));
        } catch (PDOException $e) {
            echo "Error : " . $e->getMessage();
        }
}
/***************** END ADD NEW ITEM IM*********************/

/***************** START ADD FIRST LEVEL ACCOUNT*********************/
if ($_POST['action'] == "first_level_form") {
    $acct_id = clean_data($_POST['acct_id']);
    $acct_name = clean_data($_POST['acct_name']);
    $reg_id = clean_data($_POST['reg_id']);
    $address = clean_data($_POST['address']);
    $email = clean_data($_POST['email']);
    $phone_no = clean_data($_POST['phone_no']);
    $credit_limit = clean_data($_POST['credit_limit']);
    $ntn = clean_data($_POST['ntn']);
    $stax_no = clean_data($_POST['stax_no']);
    $city_id = clean_data($_POST['city_id']);
    $sp_id = clean_data($_POST['sp_id']);
    $acct_type = clean_data($_POST['acct_type']);
    $acct_date = clean_data($_POST['acct_date']);
    $cnic_no = clean_data($_POST['cnic_no']);
    try
    {
        $s_query =  "INSERT INTO nom (acct_id, acct_name, address, reg_id, email, phone, credit_limit, ntn, stax_no, city_id, sp_id, acct_type, acct_date, cnic)
VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($acct_id, $acct_name, $address, $reg_id, $email, $phone_no, $credit_limit, $ntn, $stax_no, $city_id, $sp_id, $acct_type, $acct_date, $cnic_no ));
    }
    catch(PDOException $e)
    {
        echo "Error : ". $e->getMessage();
    }


  $acctid_l3 =  substr($acct_id,-4) + 1;

    $acct_id = substr($acct_id,0,6).str_pad($acctid_l3,4,"0", STR_PAD_LEFT);
}
/***************** END ADD FIRST LEVEL ACCOUNT*********************/

/***************** START ADD REGION*********************/
if ($_POST['action'] == "add_reg") {
    $acct_id = clean_data($_POST['acct_id']);
    $acct_name = clean_data($_POST['acct_name']);
    try
    {
        $s_query =  "INSERT INTO regions (reg_id, reg_name)
VALUES (?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($acct_id, $acct_name));
    }
    catch(PDOException $e)
    {
        echo "Error : ". $e->getMessage();
    }

}
/***************** END ADD REGION*********************/



/***************** START ADD PARTY ADDRESS*********************/
if ($_POST['action'] == "party_address_add") {
    $p_acct_id = clean_data($_POST['p_acct_id']);
    $p_acct_name = clean_data($_POST['p_acct_name']);
    $reg_id = clean_data($_POST['reg_id']);
    $address = clean_data($_POST['address']);
    $email = clean_data($_POST['email']);
    $phone_no = clean_data($_POST['phone_no']);
    try
    {
        $s_query =  "INSERT INTO nom_add (acct_id, add_line1, reg_id, email, phone)
VALUES (?, ?, ?, ?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($p_acct_id, $address, $reg_id, $email, $phone_no ));
    }
    catch(PDOException $e)
    {
        echo "Error : ". $e->getMessage();
    }

}
/***************** END ADD PARTY ADDRESS*********************/




/***************** START ADD NEW CARGO*********************/
if ($_POST['action'] == "add_cargo") {


    $acct_id = clean_data($_POST['acct_id']);
    $acct_name = clean_data($_POST['acct_name']);


    try {
        $s_query = "INSERT INTO cargo (acct_id, acct_name)VALUES (?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($acct_id, $acct_name));
    } catch (PDOException $e) {
        echo "Error : " . $e->getMessage();
    }
}
/***************** END ADD NEW CARGO*********************/

/***************** START ADD NEW SMS SENT*********************/
if ($_POST['action'] == "add_sms") {


include("../include/sms_function.php");

    $datetime = date('Y-m-d H:i:s');

    $sms_id = clean_data($_POST['acct_id']);
    $phone_no = clean_data($_POST['phone_no']);
    $message = clean_data($_POST['message']);

 //   echo '123'.$message.$phone_no;

    $send = sendSmsMessage($message, $phone_no, 'KAFELtrader', '');
//    $send = sendSmsMessage($message, $phone_no, 'KafelTrader', '');

    if($send == true)
    {
        echo 'Message Hase Been Sent';

    }
    else
    {
        echo 'ERROR';
    }




    try {
        $s_query = "INSERT INTO sms_sent (sms_id, phone_no, message, post_date)VALUES (?, ?, ?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($sms_id, $phone_no, $message, $datetime));
    } catch (PDOException $e) {
        echo "Error : " . $e->getMessage();
    }
}

/***************** END ADD NEW SMS SENT*********************/

/***************** START ADD NEW LOCATIONS*********************/
if ($_POST['action'] == "add_loc") {


    $cat_id = clean_data($_POST['acct_id']);
    $cat_name = clean_data($_POST['acct_name']);


    try {
        $s_query = "INSERT INTO location (loc_id, loc_name)VALUES (?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($cat_id, $cat_name));
    } catch (PDOException $e) {
        echo "Error : " . $e->getMessage();
    }


}
/***************** END ADD NEW LOCATION*********************/




/***************** START ADD NEW BRAND*********************/
if ($_POST['action'] == "add_brand") {


    $cat_id = clean_data($_POST['acct_id']);
    $cat_name = clean_data($_POST['acct_name']);


    try {
        $s_query = "INSERT INTO prod_type (type_id, type_name)VALUES (?, ?)";
        $results = $dbcon->prepare($s_query);
        $results->execute(array($cat_id, $cat_name));
    } catch (PDOException $e) {
        echo "Error : " . $e->getMessage();
    }
}
/***************** END ADD NEW LOCATION*********************/

?>